# Uses of Interface
org.bukkit.configuration.Configuration

Packages that use Configuration
Package
Description
org.bukkit.configuration
Classes dedicated to handling a plugin's runtime configuration.
org.bukkit.configuration.file
Classes dedicated to facilitating `configurations` to be read and stored on the filesystem.

## Uses of Configuration in org.bukkit.configuration

Classes in org.bukkit.configuration that implement Configuration
Modifier and Type
Class
Description
`class`
`MemoryConfiguration`
This is a `Configuration` implementation that does not save or load from any source, and stores all values in memory only.
Fields in org.bukkit.configuration declared as Configuration
Modifier and Type
Field
Description
`protected Configuration`
MemoryConfiguration.`defaults`
Methods in org.bukkit.configuration that return Configuration
Modifier and Type
Method
Description
`@NotNull Configuration`
ConfigurationOptions.`configuration()`
Returns the `Configuration` that this object is responsible for.
`@Nullable Configuration`
Configuration.`getDefaults()`
Gets the source `Configuration` for this configuration.
`@Nullable Configuration`
MemoryConfiguration.`getDefaults()`
`@Nullable Configuration`
ConfigurationSection.`getRoot()`
Gets the root `Configuration` that contains this `ConfigurationSection`
`@Nullable Configuration`
MemorySection.`getRoot()`
Methods in org.bukkit.configuration with parameters of type Configuration
Modifier and Type
Method
Description
`void`
Configuration.`addDefaults(@NotNull Configuration defaults)`
Sets the default values of the given paths as provided.
`void`
MemoryConfiguration.`addDefaults(@NotNull Configuration defaults)`
`void`
Configuration.`setDefaults(@NotNull Configuration defaults)`
Sets the source of all default values for this `Configuration`.
`void`
MemoryConfiguration.`setDefaults(@NotNull Configuration defaults)`
Constructors in org.bukkit.configuration with parameters of type Configuration
Modifier
Constructor
Description
`protected`
`ConfigurationOptions(@NotNull Configuration configuration)`
``
`MemoryConfiguration(@Nullable Configuration defaults)`
Creates an empty `MemoryConfiguration` using the specified `Configuration` as a source for all default values.

## Uses of Configuration in org.bukkit.configuration.file

Classes in org.bukkit.configuration.file that implement Configuration
Modifier and Type
Class
Description
`class`
`FileConfiguration`
This is a base class for all File based implementations of `Configuration`
`class`
`YamlConfiguration`
An implementation of `Configuration` which saves all files in Yaml.
Constructors in org.bukkit.configuration.file with parameters of type Configuration
Modifier
Constructor
Description
``
`FileConfiguration(@Nullable Configuration defaults)`
Creates an empty `FileConfiguration` using the specified `Configuration` as a source for all default values.